<?php
require __DIR__.'/vendor/autoload.php';
require __DIR__.'/vendor/zeedhi/framework/bootstrap.php';
require __DIR__.'/vendor/teknisa/libraries/scripts/bootstrap.php';

$instanceManager = \Zeedhi\Framework\DependencyInjection\InstanceManager::getInstance();

$instanceManager->loadFromFile(__DIR__.'/config/environment.xml');
$instanceManager->loadFromFile(__DIR__.'/config/fileServer.xml');

$instanceManager->loadFromFile(__DIR__.'/config/db.xml');
$instanceManager->loadFromFile(__DIR__.'/config/parameters.xml');

$routes = array();
$productMapping = file_get_contents(__DIR__.'/config/servicesMapping.json');
$productMapping = json_decode($productMapping, true);
foreach ($productMapping as $path) {
    $ext = substr(strrchr($path, '.'),1);
    if ($ext === 'xml') {
        $instanceManager->loadFromFile(__DIR__.$path);
    } elseif ($ext === 'json') {
        $routes[] = __DIR__.$path;
    }
}

$routes[] = __DIR__.'/vendor/teknisa/libraries/libRoutes.json';

$instanceManager->registerService('routeParser', new \Zeedhi\Framework\Routing\Parsers\JSONFormat($routes));

$instanceManager->compile();

$entity_manager = $instanceManager->getService('entityManager');
\Setforms2\Shared\Registry::store('EntityManager', $entity_manager);
\Setforms2\Shared\Registry::store('EntityManagerConnection', $entity_manager->getConnection());