<?php
namespace BancoTalentos\Controllers;

use BancoTalentos\Services\LoginService;
use Zeedhi\Framework\DTO\{ Request, Response };
use Zeedhi\Framework\DataSource\DataSet;
use Zeedhi\Framework\DTO\Response\{ Error, Message };
use BancoTalentos\Util\ExpectedException;

class LoginController {
    /** @param LoginService */
    protected $loginService;

    public function __construct(
        LoginService $loginService
    ) {
        $this->loginService = $loginService;
    }

    public function loginGoogle(
        Request\Row $request,
        Response $response
    ) {
        try {
            $row = $request->getRow();
            $idToken = (string) $row['idtoken'];
            $requesterUrl = (string) $row['REQUESTER_URL'];

            $loginResponse = $this->loginService->loginGoogle($idToken, $requesterUrl);

            die(json_encode($loginResponse));
        } catch (ExpectedException $e) {
            $response->addMessage(new Message($e->getMessage(), Message::TYPE_ERROR));
        } catch (\Exception $e) {
            $response->setError(new Error($e->getMessage(), $e->getCode(), $e->getTrace()));
        }
    }
}