<?php
namespace BancoTalentos\Services;

use BancoTalentos\Repositories\DashboardRepository;
use BancoTalentos\Util\BTParameters;
use Zeedhi\Framework\DTO;

class DashboardService {
    /** @var BTParameters */
    protected $btParameters;

    /** @var DashboardRepository */
    protected $dashboardRepository;

    public function __construct(
        BTParameters $btParameters,
        DashboardRepository $dashboardRepository
    ) {
        $this->btParameters = $btParameters;
        $this->dashboardRepository = $dashboardRepository;
    }

    public function getStatusCadastro(): array {
        $nrOrg = (int) $this->btParameters->getNrOrg();
        $nrParcNegocio = (int) $this->btParameters->getNrParcNegocio();

        $statusCadastro = $this->dashboardRepository->getStatusCadastro(
            $nrOrg, $nrParcNegocio
        );

        return $statusCadastro;
    }

    public function getQtVagasRelacionadas(): array {
        $nrParcNegocio = (int) $this->btParameters->getNrParcNegocio();

        $qtVagasRel = $this->dashboardRepository->getQtVagasRelacionadas($nrParcNegocio);
        return $qtVagasRel;
    }

    public function getUltimaAtualizacao() {
        $nrOrg = (int) $this->btParameters->getNrOrg();
        $nrParcNegocio = (int) $this->btParameters->getNrParcNegocio();

        $ultAtu = $this->dashboardRepository->getUltimaAtualizacao(
            $nrOrg, $nrParcNegocio
        );

        return $ultAtu;
    }

}