<?php

namespace BancoTalentos\Util;

use Teknisa\Libs\Util\Configuration;
use \Zeedhi\Framework\DataSource\Manager\Doctrine\NameProvider;

class NameProviderImpl implements NameProvider {

    public function getClassName($tableName) {
        
        if($tableName == 'ZHU_ACCESS_CONTROL_RULE') {
            return 'ZeedhiUser\Model\AccessControl\Entities\ZhuAccessControlRule';
        } else if($tableName == 'ZH_PREFERENCE_LAYOUT') {
            return 'Zeedhi\Preferences\API\Model\Entities\ZhPreferenceLayout';
        } else if($tableName == 'ZH_PREFERENCE_FILTER') {
            return 'Zeedhi\Preferences\API\Model\Entities\ZhPreferenceFilter';
        } else if($tableName == 'ZH_PREFERENCE_VIEW') {
            return 'Zeedhi\Preferences\API\Model\Entities\ZhPreferenceView';
        } else if($tableName == 'ZH_USER_WIDGET') {
            return 'Zeedhi\Preferences\API\Model\Entities\ZhUserWidget';
        }
        return false;
    }

    public function getDataSourceByName($dataSourceName) {
        $dataSourcesSubModels = $this->getDataSources();
        $dataSourceDirectory = $dataSourcesSubModels[$dataSourceName];
        return Configuration::factoryFromFileLocation($dataSourceDirectory, $dataSourceName);
    }

    private function getDataSources() {
        $ds = DIRECTORY_SEPARATOR;
        $gerDataSources = $this->getGerDataSources($ds);
        $preferencesDataSources = $this->getPreferencesDataSources($ds);
        $moduleDataSources = $this->getModuleDataSources($ds);
        return array_merge($preferencesDataSources, $gerDataSources, $moduleDataSources);
    }

    private function getGerDataSources($ds) {
        $dataSources = file_get_contents(__DIR__.$ds.'..'.$ds.'..'.$ds.'..'.$ds.'..'.$ds.'modules'.$ds.'acl'.$ds.'backend'.$ds.'config'.$ds.'dataSourcesMapping.json');
        $dataSources = str_replace('../../teknisa', '../modules/teknisa', $dataSources);
        return json_decode($dataSources, true);
    }

    private function getModuleDataSources($ds) {
        $dataSources = file_get_contents(__DIR__.$ds.'..'.$ds.'..'.$ds.'..'.$ds.'config'.$ds.'dataSourcesMapping.json');
        return json_decode($dataSources, true);
    }
    
    private function getPreferencesDataSources() {
        $preferencesDataSourceDir = '../vendor/zeedhi/preferences/gen/datasources';
        return array(
            'filter'      => $preferencesDataSourceDir,
            'layout'      => $preferencesDataSourceDir,
            'view'        => $preferencesDataSourceDir,
            'user_widget' => $preferencesDataSourceDir
        );
    }
    
    /*public function getDataSourceByName($dataSourceName) {
        $ds = DIRECTORY_SEPARATOR;
        $file = file_get_contents(__DIR__.$ds.'..'.$ds.'..'.$ds.'..'.$ds.'config'.$ds.'dataSourcesMapping.json');
        $dataSourcesSubModels = json_decode($file, true);
        $dataSourceDirectory = $dataSourcesSubModels[$dataSourceName];
        return Configuration::factoryFromFileLocation($dataSourceDirectory, $dataSourceName);
    }*/

}